<?php

/*
@SMF hot posts 1.0.3, 2008-12-07
@copyright (c) 2007-2008 Tsarev Alexey, http://gituha.ru/joomla/smf_hot_posts/
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

  //begin validation
  defined( '_VALID_MOS' ) or die( 'Restricted access' );
  //end validation

  //parameters
  $smf_root       = $params->def('smf_root', $_SERVER['DOCUMENT_ROOT'] . '/smf/');
  $root           = $params->def('root', 0);
  $smf_only       = $params->def('smf_only', 0);
  $posts_count    = $params->def('posts_count', 10); 
  $post_length    = $params->def('post_length', 500);
  $recode         = $params->def('recode', 0);
  $charset_joomla = $params->def('charset_joomla', 'windows-1251');
  $charset_smf    = $params->def('charset_smf', 'UTF-8');
  //end

  if($root == 1) //root
    $ssi = $_SERVER['DOCUMENT_ROOT'] . '/' . trim($smf_root, '/'); else
    $ssi = rtrim($smf_root, '/');
  $ssi .= '/' . 'SSI.php';

  if(file_exists($ssi))
  {
    require_once($ssi); 

    if($smf_only == 1)
    {
      ssi_recentPosts($posts_count, null, 'echo');
      flush();
    } else
    {
      $results = ssi_recentPosts($posts_count, null, 'noecho');
//print_r($results);
//die;

      $dnf = dirname(__FILE__);

      //pre
      $hot_posts = @file_get_contents($dnf . '/' . 'mod_smf_hot_posts_template_pre.html');
      //end

      $tmpl = @file_get_contents($dnf . '/' . 'mod_smf_hot_posts_template.html');

      foreach($results as $post)
      {
        $cur_tmpl = $tmpl;

        $board  = $post['board'];
        $poster = $post['poster'];

        //preview
        $preview = $post['preview'];

        if(strlen($preview) > $post_length)
        {
          $preview = rtrim($preview, ".");
          $preview = substr($preview, 0, $post_length) . "...";
        }
        //end

        $cur_tmpl = str_replace('{post_preview}', $preview, $cur_tmpl);
        $cur_tmpl = str_replace('{post_href}',    $post['href'], $cur_tmpl);
        $cur_tmpl = str_replace('{post_subject}', $post['subject'], $cur_tmpl);
        $cur_tmpl = str_replace('{post_time}',    $post['time'], $cur_tmpl);
        $cur_tmpl = str_replace('{board_href}',   $board['href'], $cur_tmpl);
        $cur_tmpl = str_replace('{board_name}',   $board['name'], $cur_tmpl);
        $cur_tmpl = str_replace('{poster_href}',  $poster['href'], $cur_tmpl);
        $cur_tmpl = str_replace('{poster_name}',  $poster['name'], $cur_tmpl);

        $hot_posts .= $cur_tmpl;
      }

      //post
      $hot_posts .= @file_get_contents($dnf . '/' . 'mod_smf_hot_posts_template_post.html');
      //end
    }

    //recode
    if($recode == 1)
      $hot_posts = iconv($charset_smf, $charset_joomla . '//IGNORE', $hot_posts);
    //end

    echo $hot_posts;

  } else
  {
    echo 'Error: can`t find file: ' . $ssi;
  }
?>
